
import { Message, MessageReaction, User } from "discord.js";
import { logger, newRequestId, noGuildId } from "../logger";
import { Emoji, Emotes, NONE_OF_THAT } from "../constants";
import { client } from "../..";
import { isInitialAnnouncement, isVoteMessage } from "../helper/messageIdentifiers";


export const name = 'messageReactionAdd'

export async function execute(messageReaction: MessageReaction, user: User) {
	if (user.id == client.user?.id) {
		logger.info('Skipping bot reaction')
		return
	}
	const requestId = newRequestId()
	const guildId = messageReaction.message.inGuild() ? messageReaction.message.guildId : noGuildId
	const reactedUponMessage: Message = messageReaction.message.partial ? await messageReaction.message.fetch() : messageReaction.message
	if (!messageReaction.message.guild) {
		logger.warn(`Received messageReactionAdd on non-guild message.`, { requestId })
		return
	}

	logger.info(`Got reaction on message`, { requestId, guildId })
	//logger.debug(`reactedUponMessage payload: ${JSON.stringify(reactedUponMessage)}`)

	logger.info(`emoji: ${messageReaction.emoji.toString()}`)

	if (!Object.values(Emotes).includes(messageReaction.emoji.toString()) && messageReaction.emoji.toString() !== NONE_OF_THAT) {
		logger.info(`${messageReaction.emoji.toString()} currently not handled`)
		return
	}
	logger.info(`Found a match for ${messageReaction.emoji.toString()}`)
	if (isVoteMessage(reactedUponMessage)) {
		if (messageReaction.emoji.toString() === NONE_OF_THAT) {
			logger.info(`Reaction is NONE_OF_THAT on a vote message. Handling`, { requestId, guildId })
			return client.voteController.handleNoneOfThatVote(messageReaction, reactedUponMessage, requestId, guildId)
		}
		if (messageReaction.emoji.toString() === Emoji.one) {
			// do something
		}
	}
	else if (isInitialAnnouncement(reactedUponMessage)) {
		if (messageReaction.emoji.toString() === Emoji.ticket) {
			logger.error(`Got a role emoji. Not implemented yet. ${reactedUponMessage.id}`)
		}
		return
	}
}
